﻿using System;
using System.Collections.Generic;
using System.Xml.Linq;
using System.Linq;
using System.Text;
using System.Reflection;
namespace LinqTestConsole
{
    class ActivityProfile
    {
        enum Language
        {
            English = 1,
            Danish = 2,
            Dutch = 3,
            Finnish = 4,
            French = 5,
            German = 6,
            Italian = 7,
            Norwegian = 8,
            Portuguese = 9,
            Spanish = 10, 
            Swedish = 11
        }
        private XDocument Content { get; set; }
        public Int32 MessageTone { get; set; }
        public Int32 MessageVibrate { get; set; }
        public Int32? KeyTone { get; set; }
        public Int32 BacklightTimeout { get; set; }
        public Int32 AutoLight { get; set; }
        public List<FenixMainMenuItem> mainMenu { get; set; }
        public Boolean MapOrientation { get; set; }
        public Boolean AutoZoom { get; set; }
        public Boolean GoToLine { get; set; }
        public Int32 MapPointsZoom { get; set; }
        public Int32 WayPointsZoom { get; set; }
        public Int32 MarineColors { get; set; }
        public Int32 TrackRecordMethod { get; set; }
        public Double TrackInterval { get; set; }
        public Int32 UltraTracInterval { get; set; }
        public Boolean AutoStart { get; set; }
        public Boolean AutoSave { get; set; }
        public Boolean AutoPause { get; set; }
        public Boolean AnchorDrag { get; set; }
        public Double AnchorDragDist { get; set; }
        public Boolean OffCourse { get; set; }
        public Double OffCourseDist { get; set; }
        public Boolean TimeFormat { get; set; }
        public Int32 DSTMode { get; set; }
        public Int32 TimeZone { get; set; }
        public Int32 OtherTimeZone { get; set; }
        public Int32 DistanceUnits { get; set; }
        public Int32 ElevationUnits { get; set; }
        public Int32 VerticalSpeedUnits { get; set; }
        public Int32 DepthUnits { get; set; }
        public Int32 TemperatureUnits { get; set; }
        public Int32 PressureUnits { get; set; }
        public Boolean SensorMode { get; set; }
        public Int32 HeadingDisplay { get; set; }
        public Int32 NorthReference { get; set; }
        public Double MagneticVariation { get; set; }
        public Boolean Compass { get; set; }
        public Boolean CompassAutoSwitch { get; set; }
        public Int32 AltimeterAutoCalAdv { get; set; }
        public Int32 BarometerMode { get; set; }
        public Int32 AltimeterPlotType { get; set; }
        public Int32 UGridCat { get; set; }
        public Int32 UGridSubCat { get; set; }
        public Double UGridFE { get; set; }
        public Double UGridFN { get; set; }
        public Double UGridK0 { get; set; }
        public Double UGridLono { get; set; }
        public Double UGridFld7 { get; set; }
        public Double UGridFld8 { get; set; }
        public Double UGridFld9 { get; set; }
        public Double UGridLatPt2 { get; set; }
        public Double UGridLonPt2 { get; set; }
        public Double UDatumDF { get; set; }
        public Double UDatumDA { get; set; }
        public Double UDatumDX { get; set; }
        public Double UDatumDY { get; set; }
        public Double UDatumDZ { get; set; }
        public Int32 PosnFormat { get; set; }
        public Int32 DatumIdx { get; set; }
        public Int32 SpheroidIdx { get; set; }
        public Int32 SymbolGroup { get; set; }
        public Boolean HRSensorEnabled { get; set; }
        public Boolean CadenceSensorEnabled { get; set; }
        public Boolean TempeEnabled { get; set; }
        public Boolean ChirpSearchingEnabled { get; set; }
        public Int32 HoldUpKey { get; set; }
        public Int32 HoldDownKey { get; set; }
        public Int32 DataPageBackKey { get; set; }
        public Int32 DataPageUpKey { get; set; }
        public Int32 DataPageDownKey { get; set; }
        public Boolean ProxAlertNotification { get; set; }
        public FenixAlertNotification DistIntervalAlert { get; set; }
        public FenixAlertNotification DistDestinationAlert { get; set; }
        public FenixAlertNotification DistOffCourseAlert { get; set; }
        public FenixAlertNotification SpeedMinAlert { get; set; }
        public FenixAlertNotification SpeedMaxAlert { get; set; }
        public FenixAlertNotification TimeIntervalAlert { get; set; }
        public FenixAlertNotification TimeSunsetAlert { get; set; }
        public FenixAlertNotification TimeETAAlert { get; set; }
        public FenixAlertNotification ElevMinAlert { get; set; }
        public FenixAlertNotification ElevMaxAlert { get; set; }
        public FenixAlertNotification ElevAscentAlert { get; set; }
        public FenixAlertNotification ElevDescentAlert { get; set; }
        public FenixAlertNotification NavArrivalPointsAlert { get; set; }
        public FenixAlertNotification NavArrivalTracksAlert { get; set; }
        public FenixAlertNotification NavArrivalRoutesAlert { get; set; }
        public FenixAlertNotification PaceMinAlert { get; set; }
        public FenixAlertNotification PaceMaxAlert { get; set; }
        public FenixAlertNotification HRMinAlert { get; set; }
        public FenixAlertNotification HRMaxAlert { get; set; }
        public FenixAlertNotification CadMinAlert { get; set; }
        public FenixAlertNotification CadMaxAlert { get; set; }
        public FenixAlertNotification BattPercentAlert { get; set; }
        public Int32 TimePageLayout { get; set; }
        public Int32 SecondsStyle { get; set; }
        public Int32 TimePageData { get; set; }
        public Boolean TimePageIcons { get; set; }
        //DataPages contains a collection of the actual data pages
        public List<FenixDataPage> DataPages { get; set; }
        public List<FenixDataPage> NavDataPages { get; set; }
        public List<FenixDataPage> IndoorDataPages { get; set; }
        public Int32 FitProfileAge { get; set; }
        public Double FitProfileHeight { get; set; }
        public Double FitProfileWeight { get; set; }
        public Boolean FitProfileGender { get; set; }
        public Boolean FitProfileLifetimeAthlete { get; set; }
        public Double FitProfileHRZone1 { get; set; }
        public Double FitProfileHRZone2 { get; set; }
        public Double FitProfileHRZone3 { get; set; }
        public Double FitProfileHRZone4 { get; set; }
        public Double FitProfileHRZone5 { get; set; }
        public Double FitProfileMaxHR { get; set; }
        public Boolean FitProfileAutoLap { get; set; }
        public Double FitProfileAutoLapDist { get; set; }
        public Int32 FitActivity { get; set; }
        public Boolean FileOutputGPX { get; set; }
        public Boolean FileOutputFIT { get; set; }
        public Int32 CompassPrimaryLetters { get; set; }
        public Int32 TrainingIndoors { get; set; }
        public Int32 FootPodSpeed { get; set; }
        public Boolean FootPod { get; set; }
        public Int32 SpdCadSpd { get; set; }
        public Boolean UserWritten { get; set; }
        public Boolean AutoAddFitHistory { get; set; }
        public Int32 FootPodCalFactor { get; set; }
        public Int32 SpdCadWheelSize { get; set; }
        public Int32 SpdCadAutoCal { get; set; }
        public Int32 AutoPauseNtfcn { get; set; }
        public Int32 AutoLapNtfcn { get; set; }
        public Boolean ThreeDSpeed { get; set; }
        public Boolean ThreeDDistance { get; set; }
        public Boolean SkiModeAutoLap { get; set; }
        public Boolean SkiModeAutoPause { get; set; }
        public ActivityProfile()
        {
            AnchorDrag = false;
            AnchorDragDist = 0.0000;
            OffCourse = false;
            OffCourseDist = 500.0000;
            OtherTimeZone = 0;
            SymbolGroup = 0;
            UserWritten = true;
            AutoAddFitHistory = true;
            FootPodCalFactor = 1000;
            SpdCadWheelSize = 2100;
            SpdCadAutoCal = 0;
        }

        private static string GetElementValue(XContainer element, string name)
        {
            if ((element == null) || (element.Element(name) == null))
                return String.Empty;
            return element.Element(name).Value;
        }
        public static ActivityProfile LoadFromXML(String p_XMLContent)
        {
            ActivityProfile outProfile = new ActivityProfile();
            XDocument thisDoc = XDocument.Parse(p_XMLContent);
            var settingsObj = (from settings in thisDoc.Descendants("Settings")
                               select new ActivityProfile
                               {
                                   //TODO: Handle null Boolean values
                                   MessageTone = (Int32?)settings.Element("MsgTone") ?? 0,
                                   MessageVibrate = (Int32?)settings.Element("MsgVibrate") ?? 0,
                                   KeyTone = (Int32?)settings.Element("KeyTone") ?? 0,
                                   BacklightTimeout = (Int32?)settings.Element("BacklightTimeout") ?? 1,
                                   AutoLight = (Int32?)settings.Element("AutoLight") ?? 0,
                                   MapOrientation = (Boolean)settings.Element("MapOrientation"),
                                   AutoZoom = (Boolean)settings.Element("AutoZoom"),
                                   GoToLine = (Boolean)settings.Element("GoToLine"),
                                   MapPointsZoom = (Int32?)settings.Element("MapPointsZoom") ?? 0,
                                   WayPointsZoom = (Int32?)settings.Element("WaypointsZoom") ?? 0,
                                   MarineColors = (Int32?)settings.Element("MarineColors") ?? 0,
                                   TrackRecordMethod = (Int32?)settings.Element("TrackRecordMethod") ?? 1,
                                   TrackInterval = (Double?)settings.Element("TrackInterval") ?? 7.5,
                                   UltraTracInterval = (Int32?)settings.Element("UltraTracInterval") ?? 60,
                                   AutoStart = (Boolean)settings.Element("AutoStart"),
                                   AutoSave = (Boolean)settings.Element("AutoSave"),
                                   AutoPause = (Boolean)settings.Element("AutoPause"),
                                   AnchorDrag = (Boolean)settings.Element("AnchorDrag"),
                                   OffCourse = (Boolean)settings.Element("OffCourse"),
                                   OffCourseDist = (Double?)settings.Element("OffCourseDist") ?? 0, 
                                   TimeFormat = (Boolean)settings.Element("TimeFormat"),
                                   DSTMode = (Int32?)settings.Element("DSTMode") ?? 2,
                                   OtherTimeZone = (Int32?)settings.Element("OtherTimeZone") ?? 0,
                                   TimeZone = (Int32?)settings.Element("TimeZone") ?? 28,
                                   DistanceUnits = (Int32?)settings.Element("DistanceUnits") ?? 10,
                                   ElevationUnits = (Int32?)settings.Element("ElevationUnits") ?? 8,
                                   VerticalSpeedUnits = (Int32?)settings.Element("VerticalSpeedUnits") ?? 0,
                                   DepthUnits = (Int32?)settings.Element("DepthUnits") ?? 0,
                                   TemperatureUnits = (Int32?)settings.Element("TemperatureUnits") ?? 37,
                                   PressureUnits = (Int32?)settings.Element("PressureUnits") ?? 26,
                                   SensorMode = (Boolean)settings.Element("SensorMode"),
                                   HeadingDisplay = (Int32?)settings.Element("HeadingDisplay") ?? 0,
                                   NorthReference = (Int32?)settings.Element("NorthReference") ?? 17,
                                   MagneticVariation = (Double?)settings.Element("MagneticVariation") ?? 0,
                                   Compass = (Boolean)settings.Element("Compass"),
                                   CompassAutoSwitch = (Boolean)settings.Element("CompassAutoswitch"),
                                   AltimeterAutoCalAdv = (Int32?)settings.Element("AltimeterAutoCalAdv") ?? 1,
                                   BarometerMode = (Int32?)settings.Element("BarometerMode") ?? 8,
                                   AltimeterPlotType = (Int32?)settings.Element("AltimeterPlotType") ?? 0,
                                   UGridCat = (Int32?)settings.Element("UGridCat") ?? 0,
                                   UGridSubCat = (Int32?)settings.Element("UGridSubCat") ?? 0,
                                   UGridFE = (Double?)settings.Element("UGridFE") ?? 0,
                                   UGridFN = (Double?)settings.Element("UGridFN") ?? 0,
                                   UGridK0 = (Double?)settings.Element("UGridK0") ?? 0,
                                   UGridLono = (Double?)settings.Element("UGridLono") ?? 0,
                                   UGridFld7 = (Double?)settings.Element("UGridFld7") ?? 0,
                                   UGridFld8 = (Double?)settings.Element("UGridFld8") ?? 0,
                                   UGridFld9 = (Double?)settings.Element("UGridFld9") ?? 0,
                                   UGridLatPt2 = (Double?)settings.Element("UGridLatPt2") ?? 0,
                                   UGridLonPt2 = (Double?)settings.Element("UGridLonPt2") ?? 0,
                                   UDatumDF = (Double?)settings.Element("UDatumDF") ?? 0,
                                   UDatumDA = (Double?)settings.Element("UDatumDA") ?? 0,
                                   UDatumDX = (Double?)settings.Element("UDatumDX") ?? 0,
                                   UDatumDY = (Double?)settings.Element("UDatumDY") ?? 0,
                                   UDatumDZ = (Double?)settings.Element("UDatumDZ") ?? 0,
                                   PosnFormat = (Int32?)settings.Element("PosnFormat") ?? 0,
                                   DatumIdx = (Int32?)settings.Element("DatumIdx") ?? 184,
                                   SpheroidIdx = (Int32?)settings.Element("SpheroidIdx") ?? 18,
                                   SymbolGroup = (Int32?)settings.Element("SymbolGroup") ?? 0,
                                   HRSensorEnabled = (Boolean)settings.Element("HRSensorEnabled"),
                                   CadenceSensorEnabled = (Boolean)settings.Element("CadenceSensorEnabled"),
                                   TempeEnabled = (Boolean)settings.Element("TempeEnabled"),
                                   ChirpSearchingEnabled = (Boolean)settings.Element("ChirpSearchingEnabled"),
                                   HoldUpKey = (Int32?)settings.Element("HoldUpKey") ?? 0,
                                   HoldDownKey = (Int32?)settings.Element("HoldDownKey") ?? 0,
                                   DataPageBackKey = (Int32?)settings.Element("DataPageBackKey") ?? 0,
                                   DataPageUpKey = (Int32?)settings.Element("DataPageUpKey") ?? 0,
                                   DataPageDownKey = (Int32?)settings.Element("DataPageDownKey") ?? 0,
                                   ProxAlertNotification = (Boolean)settings.Element("ProxAlertNotification"),
                                   TimePageLayout = (Int32?)settings.Element("TimePageLayout") ?? 0,
                                   SecondsStyle = (Int32?)settings.Element("SecondsStyle") ?? 0,
                                   TimePageData = (Int32?)settings.Element("TimePageData") ?? 0,
                                   TimePageIcons = (Boolean)settings.Element("TimePageIcons"),
                                   FitProfileAge = (Int32?)settings.Element("FitProfileAge") ?? 0,
                                   FitProfileHeight = (Double?)settings.Element("FitProfileHeight") ?? 0,
                                   FitProfileWeight = (Double?)settings.Element("FitProfileWeight") ?? 0,
                                   FitProfileGender = settings.Element("FitProfileGender") == null ? false : (Boolean)settings.Element("FitProfileGender"),
                                   FitProfileLifetimeAthlete = settings.Element("FitProfileLifetimeAthlete") == null ? false : (Boolean)settings.Element("FitProfileLifetimeAthlete"),
                                   FitProfileHRZone1 = (Double?)settings.Element("FitProfileHRZone1") ?? 0,
                                   FitProfileHRZone2 = (Double?)settings.Element("FitProfileHRZone1") ?? 0,
                                   FitProfileHRZone3 = (Double?)settings.Element("FitProfileHRZone1") ?? 0,
                                   FitProfileHRZone4 = (Double?)settings.Element("FitProfileHRZone1") ?? 0,
                                   FitProfileHRZone5 = (Double?)settings.Element("FitProfileHRZone1") ?? 0,
                                   FitProfileMaxHR = ElementHelper.GetElement(settings.Element("FitProfileMaxHR"), 0),
                                   FitProfileAutoLap = ElementHelper.GetElement(settings.Element("FitProfileAutoLap"), false),
                                   FitProfileAutoLapDist = ElementHelper.GetElement(settings.Element("FitProfileAutoLapDist"), 0),
                                   FitActivity = ElementHelper.GetElement(settings.Element("FITActivity"), 0),
                                   FileOutputGPX = ElementHelper.GetElement(settings.Element("FileOutputGPX"), false),
                                   FileOutputFIT = ElementHelper.GetElement(settings.Element("FileoutputFIT"), false),
                                   CompassPrimaryLetters = ElementHelper.GetElement(settings.Element("CompassPrimaryLetters"), 0),
                                   TrainingIndoors = ElementHelper.GetElement(settings.Element("TrainingIndoors"), 0),
                                   FootPodSpeed = ElementHelper.GetElement(settings.Element("FootPodSpeed"), 0),
                                   FootPod = ElementHelper.GetElement(settings.Element("FootPod"), false),
                                   SpdCadSpd = ElementHelper.GetElement(settings.Element("SpdCadSpeed"), 0),
                                   UserWritten = ElementHelper.GetElement(settings.Element("UserWritten"), false),
                                   AutoAddFitHistory = ElementHelper.GetElement(settings.Element("AutoAddFitHistory"), false),
                                   FootPodCalFactor = ElementHelper.GetElement(settings.Element("FootPodCalFactor"), 0),
                                   SpdCadWheelSize = ElementHelper.GetElement(settings.Element("SpdCadWheelSize"), 0),
                                   SpdCadAutoCal = ElementHelper.GetElement(settings.Element("SpdCadAutoCal"), 0),
                                   AutoPauseNtfcn = ElementHelper.GetElement(settings.Element("AutoPauseNtfcn"), 0),
                                   AutoLapNtfcn = ElementHelper.GetElement(settings.Element("AutoLapNtfcn"), 0),
                                   ThreeDSpeed = ElementHelper.GetElement(settings.Element("ThreeDSpeed"), false),
                                   ThreeDDistance = ElementHelper.GetElement(settings.Element("ThreeDDistance"), false),
                                   SkiModeAutoLap = ElementHelper.GetElement(settings.Element("SkiModeAutoLap"), false),
                                   SkiModeAutoPause = ElementHelper.GetElement(settings.Element("SkiModeAutoPause"), false)
                               }
            );
            outProfile = settingsObj.First();
            outProfile.mainMenu = FenixMainMenuItem.ParseMenuItems(thisDoc);
            //Use Reflection to loop through the FenixAlertNotifications in the object and populate them from XML
            Type myType = outProfile.GetType();
            PropertyInfo[] propertyInfos = myType.GetProperties();
            foreach (PropertyInfo item in propertyInfos)
            {
                if(item.PropertyType == typeof(FenixAlertNotification))
                {
                    try
                    {
                        FenixAlertNotification thisAlert = FenixAlertNotification.GetAlertNotification(thisDoc, item.Name);
                        var thisItem = outProfile.GetType().GetProperty(item.Name);
                        thisItem.SetValue(outProfile, thisAlert, null);
                    }
                    catch (SystemException ex)
                    {
                        continue;
                    }
                }
            }
            outProfile.DataPages = FenixDataPage.ParseDataPages(thisDoc, "DataPage");
            outProfile.NavDataPages = FenixDataPage.ParseDataPages(thisDoc, "NavDataPage");
            outProfile.IndoorDataPages = FenixDataPage.ParseDataPages(thisDoc, "IndoorDataPage");
            outProfile.TimeETAAlert = FenixAlertNotification.GetAlertNotification(thisDoc, "TimeETAAlert");
            return outProfile;
        }
        public XDocument ExportToXML()
        {
            XDocument outDoc = new XDocument(new XDeclaration("1.0", "UTF-8", "yes"),
                new XElement("Profile",
                    new XElement("Settings",
                        new XElement("MsgTone", MessageTone),
                        new XElement("MsgVibrate", MessageVibrate),
                        new XElement("KeyTone", KeyTone),
                        new XElement("BacklightTimeout", BacklightTimeout),
                        new XElement("AutoLight", AutoLight),
                        new XElement("MainMenu", (from menu in mainMenu
                                                  where menu.menuItem != null
                                              select new XElement("MmItem", menu.menuItem))),
                        new XElement("MapOrientation", MapOrientation),
                        new XElement("AutoZoom", AutoZoom),
                        new XElement("GoToLine", GoToLine),
                        new XElement("MapPointsZoom", MapPointsZoom),
                        new XElement("WaypointsZoom", WayPointsZoom),
                        new XElement("MarineColors", MarineColors),
                        new XElement("TrackRecordMethod", TrackRecordMethod),
                        new XElement("TrackInterval", TrackInterval),
                        new XElement("UltraTracInterval", UltraTracInterval),
                        new XElement("AutoStart", AutoStart),
                        new XElement("AutoSave", AutoSave),
                        new XElement("AutoPause", AutoPause),
                        new XElement("AnchorDrag", AnchorDrag),
                        new XElement("AnchorDragDist", AnchorDragDist),
                        new XElement("OffCourse", OffCourse),
                        new XElement("OffCourseDist", OffCourseDist),
                        new XElement("TimeFormat", TimeFormat),
                        new XElement("DstMode", DSTMode),
                        new XElement("OtherTimeZone", OtherTimeZone),
                        new XElement("TimeZone", TimeZone),
                        new XElement("DistanceUnits", DistanceUnits),
                        new XElement("ElevationUnits", ElevationUnits),
                        new XElement("VerticalSpeedUnits", VerticalSpeedUnits),
                        new XElement("DepthUnits", DepthUnits),
                        new XElement("TemperatureUnits", TemperatureUnits),
                        new XElement("PressureUnits", PressureUnits),
                        new XElement("SensorMode", SensorMode),
                        new XElement("HeadingDisplay", HeadingDisplay),
                        new XElement("NorthReference", NorthReference),
                        new XElement("MagneticVariation", MagneticVariation),
                        new XElement("Compass", Compass),
                        new XElement("CompassAutoswitch", CompassAutoSwitch),
                        new XElement("AltimeterAutoCalAdv", AltimeterAutoCalAdv),
                        new XElement("BarometerMode", BarometerMode),
                        new XElement("AltimeterPlotType", AltimeterPlotType),
                        new XElement("UGridCat", UGridCat),
                        new XElement("UGridSubCat", UGridSubCat),
                        new XElement("UGridFE", UGridFE),
                        new XElement("UGridFN", UGridFN),
                        new XElement("UGridK0", UGridK0),
                        new XElement("UGridLono", UGridLono),
                        new XElement("UGridFld7", UGridFld7),
                        new XElement("UGridFld8", UGridFld8),
                        new XElement("UGridFld9", UGridFld9),
                        new XElement("UGridLatPt2", UGridLatPt2),
                        new XElement("UGridLonPt2", UGridLonPt2),
                        new XElement("UDatumDF", UDatumDF),
                        new XElement("UDatumDA", UDatumDA),
                        new XElement("UDatumDX", UDatumDX),
                        new XElement("UDatumDY", UDatumDY),
                        new XElement("UDatumDZ", UDatumDZ),
                        new XElement("PosnFormat", PosnFormat),
                        new XElement("DatumIdx", DatumIdx),
                        new XElement("SpheroidIdx", SpheroidIdx),
                        new XElement("SymbolGroup", SymbolGroup),
                        new XElement("HRSensorEnabled", HRSensorEnabled),
                        new XElement("CadenceSensorEnabled", CadenceSensorEnabled),
                        new XElement("TempeEnabled", TempeEnabled),
                        new XElement("ChirpSearchingEnabled", ChirpSearchingEnabled),
                        new XElement("HoldUpKey", HoldUpKey),
                        new XElement("HoldDownKey", HoldDownKey),
                        new XElement("DataPageBackKey", DataPageBackKey),
                        new XElement("DataPageUpKey", DataPageUpKey),
                        new XElement("DataPageDownKey", DataPageDownKey),
                        new XElement("ProxAlertNotification", ProxAlertNotification),
                        DistIntervalAlert.ToXML("DistIntervalAlert"),
                        DistDestinationAlert.ToXML("DistDestinationAlert"),
                        DistOffCourseAlert.ToXML("DistOffCourseAlert"),
                        SpeedMinAlert.ToXML("SpeedMinAlert"),
                        SpeedMaxAlert.ToXML("SpeedMaxAlert"),
                        TimeIntervalAlert.ToXML("TimeIntervalAlert"),
                        TimeSunsetAlert.ToXML("TimeSunsetAlert"),
                        TimeETAAlert.ToXML("TimeETAAlert"),
                        ElevMinAlert.ToXML("ElvMinAlert"),
                        ElevMaxAlert.ToXML("ElvMaxAlert"),
                        ElevAscentAlert.ToXML("ElvAscentAlert"),
                        ElevDescentAlert.ToXML("ElvDecentAlert"),
                        NavArrivalPointsAlert.ToXML("NavArrivalPointsAlert"),
                        NavArrivalTracksAlert.ToXML("NavArrivalTracksAlert"),
                        NavArrivalRoutesAlert.ToXML("NavArrivalRoutesAlert"),
                        PaceMinAlert.ToXML("PaceMinAlert"),
                        PaceMaxAlert.ToXML("PaceMaxAlert"),
                        HRMinAlert.ToXML("HRMinAlert"),
                        HRMaxAlert.ToXML("HRMaxAlert"),
                        CadMinAlert.ToXML("CadMinAlert"),
                        CadMaxAlert.ToXML("CadMaxAlert"),
                        BattPercentAlert.ToXML("BattPercentAlert"),
                        new XElement("TimePageLayout", TimePageLayout),
                        new XElement("SecondsStyle", SecondsStyle),
                        new XElement("TimePageData", TimePageData),
                        new XElement("TimePageIcons", TimePageIcons),
                        FenixDataPage.ToXML("DataPage", DataPages),
                        FenixDataPage.ToXML("NavDataPage", NavDataPages),
                        FenixDataPage.ToXML("IndoorDataPage", IndoorDataPages),
                        new XElement("FitProfileAge", FitProfileAge),
                        new XElement("FitProfileHeight", FitProfileHeight),
                        new XElement("FitProfileWeight", FitProfileWeight),
                        new XElement("FitProfileGender", FitProfileGender),
                        new XElement("FitProfileLifetimeAthlete", FitProfileLifetimeAthlete),
                        new XElement("FitProfileHRZone1", FitProfileHRZone1),
                        new XElement("FitProfileHRZone2", FitProfileHRZone2),
                        new XElement("FitProfileHRZone3", FitProfileHRZone3),
                        new XElement("FitProfileHRZone4", FitProfileHRZone4),
                        new XElement("FitProfileHRZone5", FitProfileHRZone5),
                        new XElement("FitProfileMaxHR", FitProfileMaxHR),
                        new XElement("FitProfileAutoLap", FitProfileAutoLap),
                        new XElement("FitProfileAutoLapDist", FitProfileAutoLapDist),
                        new XElement("FitActivity", FitActivity),
                        new XElement("FileOutputGPX", FileOutputGPX),
                        new XElement("FileOutputFIT", FileOutputFIT),
                        new XElement("CompassPrimaryLetters", CompassPrimaryLetters),
                        new XElement("TrainingIndoors", TrainingIndoors),
                        new XElement("FootPodSpeed", FootPodSpeed),
                        new XElement("FootPod", FootPod),
                        new XElement("SpdCadSpeed", SpdCadSpd),
                        new XElement("UserWritten", UserWritten),
                        new XElement("AutoAddFitHistory", AutoAddFitHistory),
                        new XElement("FootPodCalFactor", FootPodCalFactor),
                        new XElement("SpdCadWheelSize", SpdCadWheelSize),
                        new XElement("SpdCadAutoCal", SpdCadAutoCal),
                        new XElement("AutoPauseNtfcn", AutoPauseNtfcn),
                        new XElement("AutoLapNtfcn", AutoLapNtfcn),
                        new XElement("ThreeDSpeed", ThreeDSpeed),
                        new XElement("ThreeDDistance", ThreeDDistance),
                        new XElement("SkiModeAutoLap", SkiModeAutoLap),
                        new XElement("SkiModeAutoPause", SkiModeAutoPause)
                        )
                    )
                );


            return outDoc;
        }
    }
}
